#
# Normalize a nested list
#
# This routine replaces all the element delimiting whitespace
# with a single space. This allows lsort to do the right
# thing without triping on delimiting whitespace.
#

proc lnorm {list} {
  set r {}
  foreach el $list {
    if {[llength $el] == 1} {
      lappend r $el
    } else {
      lappend r [lnorm $el]
    }
  }
  return $r
}
# Check equality of two arrays where any list entries
# have no order significance

proc arraysEq {ar1 ar2} {
  upvar $ar1 mar1
  upvar $ar2 mar2
  if {![array exists mar1] ||\
	  ![array exists mar2] ||\
	  [array size mar1] != [array size mar2]} {return 0}
  foreach ent [array names mar1] {
    if {![info exists mar2($ent)] ||\
	    [lsort  $mar1($ent)] != [lsort $mar2($ent)]} {return 0}
  }
  return 1
}